---
title: Unix Detailed Build Instructions
slug: Mozilla/Developer_guide/Build_Instructions/Unix_Detailed_Build_Instructions
tags:
  - Build documentation
  - Developing Mozilla
---
<p>This is a guide to building Mozilla on Unix including,</p>

<ul>
 <li>A list of the required development tools.</li>
 <li>Commands to build Mozilla using the Autoconf build system.</li>
</ul>

<p>For documentation on developing features or fixing bugs, look at the <a href="en">Mozilla Technical Documents</a> or <a class="external" href="http://www.mozilla.org/library.html">Mozilla Library</a>. For general Unix issues, look at the <a class="external" href="http://www.mozilla.org/unix/">Mozilla Unix</a>.</p>

<h3 id="Other_Unix_Build_pages">Other Unix Build pages</h3>

<ul>
 <li><a href="en/Adding_Files_to_the_Build">How to add files and not break the build</a>.</li>
 <li><a class="external" href="http://www.mozilla.org/build/configurator-faq.html">Build Configuator FAQ</a>: FAQ for the <a class="external" href="http://webtools.mozilla.org/build/config.cgi">Unix Build Configurator</a>.</li>
</ul>

<h3 id="Requirements">Requirements</h3>

<p>See the <a href="en/Linux_Build_Prerequisites">Unix build requirements</a>.</p>

<h3 id="Get_the_Code">Get the Code</h3>

<p>There are two ways to get the code:</p>

<h4 id="FTP"><a href="en/Mozilla_Source_Code_(HTTP%2f%2fFTP)">FTP</a></h4>

<p>Drops are generally produced at least once per week (usually daily), and are known to compile and even run on a few platforms.</p>

<h4 id="CVS"><a href="en/Mozilla_Source_Code_(CVS)">CVS</a></h4>

<p>Provides the most current code, but is slower than ftp. (First check that <a class="external" href="http://tinderbox.mozilla.org/showbuilds.cgi?tree=SeaMonkey">Tinderbox</a> is green to be sure it will compile.)</p>

<pre class="eval">setenv CVSROOT <a class="link-mailto" href="mailto::pserver:anonymous@cvs-mirror.mozilla.org" rel="freelink">:pserver:anonymous@cvs-mirror.mozilla.org</a>:/cvsroot
cvs login
<span class="highlightgreen">(password: anonymous) (You only need to login once)</span>
cvs co mozilla/client.mk
cd mozilla
gmake -f client.mk checkout
</pre>

<p>The makefile pulls the right source for building mozilla, which includes some tagged branches (e.g., NSPR).</p>

<p>Do not try to manually check out the mozilla/ CVS tree on the HEAD branch. It will not work.</p>

<h3 id="Build_the_Lizard">Build the Lizard</h3>

<h4 id="Manually_drive_the_build">Manually drive the build</h4>

<ol>
 <li><code>cd mozilla</code></li>
 <li><code>./configure <var>{{ mediawiki.external('options') }}</var></code><br>
  For configure options, run <code>./configure --help</code>, or use the <a class="external" href="http://webtools.mozilla.org/build/config.cgi">Unix Build Configurator</a>.<em>If you don't know what a configure option does</em>, don't use it. The default is to create a un-optimized build with debugging information. If you want an optimized build, use the configure options <code>--disable-debug --enable-optimize</code>.</li>
 <li><code>gmake</code></li>
</ol>

<p>Once you have configured, you only have to run <strong><code>configure</code></strong> if you add or remove Makefile.in files (cvs update can do this. Beware!). The list of makefiles is in <strong><code>mozilla/allmakefiles.sh</code></strong></p>

<p>For build system hackers: If you change configure.in, cd to mozilla, and run <strong><code>autoconf-2.13</code></strong>. This generates a new configure script. (When you checkin configure.in, cvs will run autoconf and check in a new configure script for you).</p>

<h4 id="Automated_build_.28client.mk.29">Automated build (client.mk)</h4>

<ol>
 <li>Save the script from <a class="external" href="http://webtools.mozilla.org/build/config.cgi">Unix Build Configurator</a> as <strong><code>~/.mozconfig</code></strong>.</li>
 <li><code>cvs co -f mozilla/client.mk</code></li>
 <li><code>cd mozilla</code></li>
 <li><code>gmake -f client.mk</code></li>
</ol>

<p>If you want to build without pulling the tree (as in, you already have the source lying around), <code>gmake -f client.mk build</code></p>

<p>If you just want to pull the tree, <code>gmake -f client.mk checkout</code></p>

<p>If you want to build <a class="external" href="http://www.mozilla.com/firefox/">Firefox</a>, use the {{ Source("browser/config/mozconfig", "example mozconfig file") }} in the mozilla/browser/config source directory.</p>

<h3 id="After_the_build">After the build</h3>

<ul>
 <li><strong><code>cd dist/bin</code></strong> and you should see links to the scripts to run the executables: <code>mozilla</code> and <code>mozilla-viewer.sh</code>.</li>
 <li>If the scripts do not work, set <strong><code>LD_LIBRARY_PATH</code></strong> and run <code>mozilla-bin</code> and <code>viewer</code> directly. Set <strong><code>LD_LIBRARY_PATH</code></strong> to include dist/bin, and the NSPR and GTK libraries. (For example, you might set it to <code>.:../../nspr/lib</code>).
  <ul>
   <li>On HP-UX, the equivalent environment variable is <code>SHLIB_PATH</code>.</li>
   <li>On AIX, the equivalent environment variable is <code>LIBPATH</code>.</li>
  </ul>
 </li>
 <li>If you run the executables from anywhere other than dist/bin, you must set the environment variable <strong><code>MOZILLA_FIVE_HOME</code></strong> to point to the<em>absolute path</em> of the dist/bin directory.</li>
 <li>Update your tree by re-checking out the source, e.g. repeating the initial checkout process.</li>
</ul>

<h3 id="etc.">etc.</h3>

<p>Parallel builds: just adding -j4 to gmake doesn't work, you need to do this:</p>

<pre>setenv MAKE gmake -j4
</pre>

<div class="originaldocinfo">
<h2 id="Original_Document_Information">Original Document Information</h2>

<ul>
 <li>Author(s): <a class="link-mailto" href="mailto:leaf@mozilla.org">Daniel Nunes</a></li>
 <li>Last Updated Date: October 9, 2004</li>
 <li>Copyright Information: Portions of this content are © 1998–2007 by individual mozilla.org contributors; content available under a Creative Commons license | <a class="external" href="http://www.mozilla.org/foundation/licensing/website-content.html">Details</a>.</li>
</ul>
</div>
